100 DATA_AREA 99
110 IMPLICIT% ch
120 max=32750
130 DIM k$(max),hunk$(20),file$(42),name$(4)
140 INK 7 : INK #0,7 : PAPER #0,0
150 CLS #0 : CSIZE #0,2,0
160 REPeat try
170   PAPER 0 : CLS : CSIZE 2,1
180   PAPER 2,0,3
190   AT 0,2 : PRINT "   Amiga 8SVX IFF sample   "
200   AT 1,2 : PRINT " to I2C Analogue converter "
210   CSIZE 2,0
220   PAPER 2
230   AT 5,2 : PRINT "v1.7  Simon N Goodwin 1994"
240   STRIP 0 : PRINT
250   CONVERT_IFF
260 END REPeat try
270 :
280 DEFine PROCedure CONVERT_IFF
290 LOCal ch,in%,size
300 REMark Converts signed 8SVX byte IFF samples
310 REMark to I2C unsigned format; uses INPUT$ & ANYOPEN%
320 REPeat loop
330   INPUT #0;"Enter IFF drive and file name:"\file$
340   IF file$="" : PRINT #0;"STOPPED" : STOP
350   in%=ANYOPEN%(file$,1)
360   IF in%>=0 : EXIT loop
370   PRINT #0;"Error " & in% & ", please try again."
380 END REPeat loop
390 HUNK name$,size
400 IF INPUT$(#in%,4)="8SVX"
410 REPeat scan
420   HUNK name$,size
430   IF name$="BODY"
440     CONVERT size : EXIT scan
450   ELSE
460     REMark Skip this hunk
470     hunk$=INPUT$(#in%,size+(size MOD 2))
480     REMark Skip nulls
490     FOR ch=LEN(hunk$) TO 2 STEP -1
500       IF hunk$(ch)=CHR$(0):hunk$=hunk$(1 TO ch-1)
510     END FOR ch
520     IF LEN(hunk$)>1
530       INK 4 : PRINT ,'"' & hunk$ & '"'
540       INK 7
550     END IF
560     IF EOF(#in%)
570       PRINT #0;"No sample body found." : EXIT scan
580     END IF
590   END IF
600 END REPeat scan
610 ELSE
620   PRINT #0;"Sample is not in IFF 8SVX format."
630 END IF
640 CLOSE #in%
650 END DEFine CONVERT_IFF
660 :
670 REFERENCE k$,k
680 DEFine PROCedure HUNK(k$,k)
690 k$=INPUT$(#in%,4)
700 PRINT "Hunk name = " & k$;
710 k=0 : FOR ch=1 TO 4:k=k*256+CODE(INKEY$(#in%,-1))
720 PRINT " Hunk size = " & k
730 END DEFine HUNK
740 :
750 DEFine PROCedure CONVERT(bytes)
760 REMark Signed bytes to unsigned, one by one!
770 LOCal ch,k%,out%
780 IF bytes>max
790   PRINT \"File too long - truncating to " & max
800   bytes=max
810 END IF
820 k$=INPUT$(#in%,bytes)
830 PRINT \"Converting sample ... ";
840 REMark OPEN #5,scr_512x256a0x0
850 FOR ch=1 TO bytes
860   k%=CODE(k$(ch))
870   IF k%>127 : k%=k%-128 : ELSE k%=k%+128
880   REMark PLOT #5,i% && 511,k%
890   k$(ch)=CHR$(k%)
900 END FOR ch
910 REMark CLOSE #5
920 PRINT "OK"
930 INPUT #0;"Enter output drive and file name:"\file$
940 out%=ANYOPEN%(file$,2)
950 IF out%>=0
960   PRINT "Saving " & file$ & " ... ";
970   PRINT #out%,k$;
980   CLOSE #out%
990   PRINT "OK"
1000 ELSE
1010   PRINT #0;"Error " & out% & ", file not saved."
1020 END IF
1030 PAUSE 75
1040 END DEFine CONVERT
1050 :
1060 DEFine PROCedure S
1070 SAVE FLP1_IFF_TO_I2C_BAS
1080 END DEFine S
